"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CardSubHeaderTypography = exports.CardHeaderTypography = exports.CardHeader = exports.CardExpandableHeader = exports.BaseHeader = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _padding = require("./padding");

var _Expandable = require("../Expandable");

var _Typography = require("../Typography");

var _designparams = require("../designparams");

var _excluded = ["children"],
    _excluded2 = ["disabled", "expanded", "onToggle", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Empty header with just a bottom border
 */
var BaseHeader = _styledComponents.default.div.withConfig({
  displayName: "CardHeader__BaseHeader",
  componentId: "sc-1cmks1w-0"
})(["flex:none;box-sizing:border-box;width:100%;height:100%;color:", ";border-bottom:1px solid ", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text04();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.element12();
});

exports.BaseHeader = BaseHeader;
var TitleHeader = (0, _styledComponents.default)(BaseHeader).withConfig({
  displayName: "CardHeader__TitleHeader",
  componentId: "sc-1cmks1w-1"
})(["display:flex;flex-direction:row;flex-wrap:nowrap;align-items:center;cursor:default;height:auto;padding:", " ", ";"], _designparams.spacing.medium, _padding.CARD_PADDING);

var TitleContainer = _styledComponents.default.div.withConfig({
  displayName: "CardHeader__TitleContainer",
  componentId: "sc-1cmks1w-2"
})(["flex:auto;display:flex;flex-direction:column;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;"]);

var CardHeaderTypography = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'card-title'
}).withConfig({
  displayName: "CardHeader__CardHeaderTypography",
  componentId: "sc-1cmks1w-3"
})([""]);
exports.CardHeaderTypography = CardHeaderTypography;
var CardSubHeaderTypography = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'caption'
}).withConfig({
  displayName: "CardHeader__CardSubHeaderTypography",
  componentId: "sc-1cmks1w-4"
})([""]);
exports.CardSubHeaderTypography = CardSubHeaderTypography;

var CardHeader = _ref3 => {
  var {
    children
  } = _ref3,
      props = _objectWithoutProperties(_ref3, _excluded);

  return /*#__PURE__*/_react.default.createElement(TitleHeader, props, children);
};
/**
 * Expandable header
 */


exports.CardHeader = CardHeader;
var ExpandableTitleHeader = (0, _styledComponents.default)(TitleHeader).withConfig({
  displayName: "CardHeader__ExpandableTitleHeader",
  componentId: "sc-1cmks1w-5"
})(["cursor:", ";", ";"], _ref4 => {
  var {
    disabled
  } = _ref4;
  return disabled ? undefined : 'pointer';
}, _ref5 => {
  var {
    expanded
  } = _ref5;
  return !expanded ? (0, _styledComponents.css)(["transition:border-bottom 50ms ease-in-out 200ms;border-bottom-color:transparent;"]) : undefined;
});

var CardExpandableHeader = _ref6 => {
  var {
    disabled = false,
    expanded = false,
    onToggle,
    children
  } = _ref6,
      props = _objectWithoutProperties(_ref6, _excluded2);

  var onClick = (0, _react.useCallback)(() => {
    if (!disabled) {
      onToggle(!expanded);
    }
  }, [disabled, onToggle, expanded]);
  return /*#__PURE__*/_react.default.createElement(ExpandableTitleHeader, _extends({
    disabled: disabled,
    expanded: expanded,
    onClick: onClick
  }, props), /*#__PURE__*/_react.default.createElement(TitleContainer, null, children), /*#__PURE__*/_react.default.createElement(_Expandable.Arrow, {
    disabled: disabled,
    expanded: expanded
  }));
};

exports.CardExpandableHeader = CardExpandableHeader;