"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TimePickerTwentyFour = exports.TimePickerAMPM = exports.MinutePicker = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _theme = require("../theme");

var _Button = require("../Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CLOCK_SIZE = 300;
var HALF_CLOCK_SIZE = CLOCK_SIZE / 2;
var QUARTER_CLOCK_SIZE = CLOCK_SIZE / 4;
var NUMBER_SIZE = CLOCK_SIZE / 6;
var HALF_NUMBER_SIZE = NUMBER_SIZE / 2;
var MIDDLE_POINT_SIZE = 10;
var HALF_MIDDLE_POINT_SIZE = MIDDLE_POINT_SIZE / 2;
var CLOCK_NUMBER_DIF = HALF_CLOCK_SIZE - HALF_NUMBER_SIZE;
var ANGLE_360 = 360;
var TIMEFORMAT_BUTTON_MIN_SIZE = 36;
var CLOCK_NUMBERS = [12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11];
var CLOCK_NUMBERS_TWENTY_FOUR = [0, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23];
var AMPM;

(function (AMPM) {
  AMPM["AM"] = "AM";
  AMPM["PM"] = "PM";
})(AMPM || (AMPM = {}));

var TimeContainer = _styledComponents.default.div.withConfig({
  displayName: "TimePicker__TimeContainer",
  componentId: "sc-8d7pyp-0"
})(["display:flex;justify-content:center;align-items:center;position:relative;padding-top:", ";height:100%;user-select:none;"], _designparams.spacing.huge);

var TimeFormatContainer = _styledComponents.default.div.withConfig({
  displayName: "TimePicker__TimeFormatContainer",
  componentId: "sc-8d7pyp-1"
})(["position:absolute;left:0;top:", ";z-index:2;"], _designparams.spacing.large);

var TimeFormatButton = (0, _styledComponents.default)(_Button.NativeButton).attrs({
  accent: false,
  visibleFocus: true
}).withConfig({
  displayName: "TimePicker__TimeFormatButton",
  componentId: "sc-8d7pyp-2"
})(["border-radius:", "px;width:fit-content;min-width:", "px;height:", "px;padding:", ";box-shadow:initial;:first-child{margin-right:", ";}background-color:", ";"], TIMEFORMAT_BUTTON_MIN_SIZE / 2, TIMEFORMAT_BUTTON_MIN_SIZE, TIMEFORMAT_BUTTON_MIN_SIZE, _designparams.spacing.small, _designparams.spacing.medium, _ref => {
  var {
    theme,
    selected
  } = _ref;
  return selected ? undefined : theme.color.background01();
});
var TimeFormatButtonLabel = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'default-text'
}).withConfig({
  displayName: "TimePicker__TimeFormatButtonLabel",
  componentId: "sc-8d7pyp-3"
})(["color:", ";"], _ref2 => {
  var {
    theme,
    selected
  } = _ref2;
  return selected ? theme.color.text00() : theme.color.text03();
});

var Clock = _styledComponents.default.div.withConfig({
  displayName: "TimePicker__Clock",
  componentId: "sc-8d7pyp-4"
})(["height:", "px;width:", "px;border-radius:", ";position:relative;background-color:", ";cursor:Move;"], CLOCK_SIZE, CLOCK_SIZE, _designparams.shape.radius.circle, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.background01();
});

var MiddlePoint = _styledComponents.default.span.withConfig({
  displayName: "TimePicker__MiddlePoint",
  componentId: "sc-8d7pyp-5"
})(["position:absolute;left:", "px;top:", "px;height:", "px;width:", "px;border-radius:50%;background-color:", ";"], (CLOCK_SIZE - MIDDLE_POINT_SIZE) / 2, (CLOCK_SIZE - MIDDLE_POINT_SIZE) / 2, MIDDLE_POINT_SIZE, MIDDLE_POINT_SIZE, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.elementPrimary();
});

var StyledPointer = _styledComponents.default.div.withConfig({
  displayName: "TimePicker__StyledPointer",
  componentId: "sc-8d7pyp-6"
})(["z-index:100;width:4px;left:calc(50% - 2px);position:absolute;top:50%;transform:rotate(", "deg);::before{content:'';position:absolute;z-index:10;height:0;top:", ";border-right:2px solid transparent;border-left:2px solid transparent;border-bottom:", " solid ", ";}::after{content:'';height:", "px;width:", "px;left:-", "px;position:absolute;top:", ";color:", ";transform:rotate(-", "deg);border-radius:50%;background-color:", ";}> *{transform:rotate(-", "deg);z-index:1000;text-align:center;line-height:", "px;height:", "px;width:", "px;left:-", "px;position:absolute;top:", ";color:", ";font-size:", ";}"], props => props.rotation, props => props.innerPointer ? "-".concat(QUARTER_CLOCK_SIZE, "px") : "-".concat(CLOCK_NUMBER_DIF, "px"), props => props.innerPointer ? "".concat(QUARTER_CLOCK_SIZE, "px") : "".concat(CLOCK_NUMBER_DIF, "px"), _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.color.elementPrimary();
}, NUMBER_SIZE, NUMBER_SIZE, HALF_NUMBER_SIZE - 1, props => props.innerPointer ? "-".concat(HALF_CLOCK_SIZE - NUMBER_SIZE, "px") : "-".concat(HALF_CLOCK_SIZE, "px"), _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.color.text00();
}, props => props.rotation, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.elementPrimary();
}, props => props.rotation, NUMBER_SIZE, NUMBER_SIZE, NUMBER_SIZE, HALF_NUMBER_SIZE - 1, props => props.innerPointer ? "-".concat(HALF_CLOCK_SIZE - NUMBER_SIZE, "px") : "-".concat(HALF_CLOCK_SIZE, "px"), _ref8 => {
  var {
    theme
  } = _ref8;
  return theme.color.text00();
}, _theme.font.size.large);

var NumberContainer = _styledComponents.default.span.withConfig({
  displayName: "TimePicker__NumberContainer",
  componentId: "sc-8d7pyp-7"
})(["text-align:center;line-height:", "px;height:", "px;width:", "px;position:absolute;top:", ";left:", ";> *{font-size:", ";line-height:", "px;}"], NUMBER_SIZE, NUMBER_SIZE, NUMBER_SIZE, props => props.y, props => props.x, _theme.font.size.large, NUMBER_SIZE);

var Pointer = _ref9 => {
  var {
    innerPointer,
    value,
    rotation
  } = _ref9;
  return /*#__PURE__*/_react.default.createElement(StyledPointer, {
    rotation: rotation,
    innerPointer: innerPointer
  }, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "button-text"
  }, value));
};

var ClockComponent = _ref10 => {
  var {
    numbers,
    value,
    innerNumbers = [],
    timeFormat = '',
    onTimeChange,
    hour12MeridiemLabels
  } = _ref10;
  var roundValue = (0, _react.useMemo)(() => ANGLE_360 / numbers.length, [numbers]);
  var numberPositions = (0, _react.useMemo)(() => {
    var {
      length
    } = numbers;
    var rotateQuarter = length / 4;
    return numbers.reduce((acc, number, index) => {
      if (length === 60 && index % 5 > 0) {
        return acc;
      }

      var math = Math.PI * 2 * ((index - rotateQuarter) / length);
      var y = CLOCK_NUMBER_DIF * Math.sin(math) + CLOCK_NUMBER_DIF;
      var x = CLOCK_NUMBER_DIF * Math.cos(math) + CLOCK_NUMBER_DIF;
      return [...acc, {
        x,
        y,
        number
      }];
    }, []);
  }, [numbers]);
  var innerNumberPositions = (0, _react.useMemo)(() => {
    var {
      length
    } = innerNumbers;
    var rotateQuarter = length / 4;
    return innerNumbers.map((number, index) => {
      var math = Math.PI * 2 * ((index - rotateQuarter) / length);
      var y = QUARTER_CLOCK_SIZE * Math.sin(math) + CLOCK_NUMBER_DIF;
      var x = QUARTER_CLOCK_SIZE * Math.cos(math) + CLOCK_NUMBER_DIF;
      return {
        x,
        y,
        number
      };
    });
  }, [innerNumbers]);
  var [rotation, setRotation] = (0, _react.useState)(numbers.includes(value) ? numbers.indexOf(value) * roundValue : innerNumbers.indexOf(value) * roundValue);
  var [selectedTab, setSelectedTab] = (0, _react.useState)(timeFormat);
  var isAMSelected = selectedTab === AMPM.AM;
  var middlePoint = (0, _react.useRef)(null);
  var setPM = (0, _react.useCallback)(() => {
    setSelectedTab(AMPM.PM);
    onTimeChange(value === 12 ? value : value + 12);
  }, [onTimeChange, value]);
  var setAM = (0, _react.useCallback)(() => {
    setSelectedTab(AMPM.AM);
    onTimeChange(value === 12 ? 0 : value);
  }, [onTimeChange, value]);
  var onMouseMove = (0, _react.useCallback)(e => {
    if (e.buttons !== 1 || middlePoint.current === null) {
      return;
    } // Calculate which degree the mouse pointer is compared to middlepoint


    var middlePointRect = middlePoint.current.getBoundingClientRect();
    var dy = middlePointRect.top + HALF_MIDDLE_POINT_SIZE - e.clientY;
    var dx = e.clientX - middlePointRect.left - HALF_MIDDLE_POINT_SIZE;
    var theta = Math.atan2(dx, dy) * 180 / Math.PI;

    if (theta < 0) {
      theta = ANGLE_360 + theta;
    }

    theta = Math.round(theta / roundValue) * roundValue;
    theta = theta > roundValue * (numbers.length - 1) ? 0 : theta;

    if (innerNumbers.length > 0) {
      // Calculate distance from middlepoint, used to know if user is clicking on inner numbers.
      var distance = Math.sqrt(Math.pow(dx, 2) + Math.pow(dy, 2));
      var clock = e.currentTarget.getBoundingClientRect();
      var distanceFromMiddle = distance / clock.width;

      if (distanceFromMiddle < 0.32) {
        var newInnervalue = innerNumbers[theta / roundValue];

        if (newInnervalue === value) {
          return;
        }

        setRotation(theta);
        onTimeChange(newInnervalue);
        return;
      }
    }

    var newValue = numbers[theta / roundValue];

    if (newValue === value) {
      return;
    }

    if (isAMSelected) {
      newValue = newValue === 12 ? 0 : newValue;
    }

    if (selectedTab === AMPM.PM) {
      newValue = newValue === 12 ? newValue : newValue + 12;
    }

    setRotation(theta);
    onTimeChange(newValue);
  }, [roundValue, numbers, innerNumbers, value, selectedTab, isAMSelected, onTimeChange]);
  return /*#__PURE__*/_react.default.createElement(TimeContainer, null, /*#__PURE__*/_react.default.createElement(Clock, {
    onMouseMove: onMouseMove,
    onMouseDown: onMouseMove
  }, /*#__PURE__*/_react.default.createElement(MiddlePoint, {
    ref: middlePoint
  }), numberPositions.map((_ref11, index) => {
    var {
      number,
      x,
      y
    } = _ref11;
    return /*#__PURE__*/_react.default.createElement(NumberContainer, {
      y: "".concat(y, "px"),
      x: "".concat(x, "px"),
      key: number,
      id: index.toString()
    }, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
      variant: "default-text"
    }, number));
  }), innerNumberPositions.map((_ref12, index) => {
    var {
      number,
      x,
      y
    } = _ref12;
    return /*#__PURE__*/_react.default.createElement(NumberContainer, {
      y: "".concat(y, "px"),
      x: "".concat(x, "px"),
      key: number,
      id: index.toString()
    }, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
      variant: "default-text"
    }, number));
  }), /*#__PURE__*/_react.default.createElement(Pointer, {
    innerPointer: innerNumbers.includes(value),
    rotation: rotation,
    value: value.toString()
  })), hour12MeridiemLabels !== undefined ? /*#__PURE__*/_react.default.createElement(TimeFormatContainer, null, /*#__PURE__*/_react.default.createElement(TimeFormatButton, {
    selected: isAMSelected,
    variant: isAMSelected ? 'primary' : 'secondary',
    onClick: setAM
  }, /*#__PURE__*/_react.default.createElement(TimeFormatButtonLabel, {
    selected: isAMSelected
  }, hour12MeridiemLabels.am)), /*#__PURE__*/_react.default.createElement(TimeFormatButton, {
    selected: !isAMSelected,
    variant: !isAMSelected ? 'primary' : 'secondary',
    onClick: setPM
  }, /*#__PURE__*/_react.default.createElement(TimeFormatButtonLabel, {
    selected: !isAMSelected
  }, hour12MeridiemLabels.pm))) : null);
};

/**
 * TimePickerTwentyFour
 *
 * Shows a clock component with 24 hour time options
 */
var TimePickerTwentyFour = _ref13 => {
  var {
    date,
    onChange
  } = _ref13;
  var onTimeChange = (0, _react.useCallback)(hour => {
    var newDate = new Date(date);
    newDate.setHours(hour);
    onChange(newDate);
  }, [date, onChange]);
  return /*#__PURE__*/_react.default.createElement(ClockComponent, {
    onTimeChange: onTimeChange,
    value: date.getHours(),
    innerNumbers: CLOCK_NUMBERS_TWENTY_FOUR,
    numbers: CLOCK_NUMBERS
  });
};

exports.TimePickerTwentyFour = TimePickerTwentyFour;

/**
 * TimePickerAMPM
 *
 * Shows a clock component with AM/PM format.
 */
var TimePickerAMPM = _ref14 => {
  var {
    date,
    onChange,
    hour12MeridiemLabels
  } = _ref14;
  var onTimeChange = (0, _react.useCallback)(hour => {
    var newDate = new Date(date);
    newDate.setHours(hour);
    onChange(newDate);
  }, [date, onChange]);
  var hours = date.getHours();
  var ampm = hours >= 12 ? AMPM.PM : AMPM.AM;
  hours = hours % 12;
  hours = hours !== 0 ? hours : 12;
  return /*#__PURE__*/_react.default.createElement(ClockComponent, {
    onTimeChange: onTimeChange,
    value: hours,
    timeFormat: ampm,
    numbers: CLOCK_NUMBERS,
    hour12MeridiemLabels: hour12MeridiemLabels
  });
};
/**
 * MinutePicker
 *
 * Shows a clock component with minute values
 */


exports.TimePickerAMPM = TimePickerAMPM;

var MinutePicker = _ref15 => {
  var {
    date,
    onChange
  } = _ref15;
  var onTimeChange = (0, _react.useCallback)(minutes => {
    var newDate = new Date(date);
    newDate.setMinutes(minutes);
    onChange(newDate);
  }, [date, onChange]);
  var minuteNumbers = (0, _react.useMemo)(() => Array(60).fill(0).map((_, i) => i), []);
  return /*#__PURE__*/_react.default.createElement(ClockComponent, {
    onTimeChange: onTimeChange,
    value: date.getMinutes(),
    numbers: minuteNumbers
  });
};

exports.MinutePicker = MinutePicker;