"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DialogHeader = exports.DialogFooter = exports.DialogContent = exports.BaseDialog = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Modal = require("../Modal");

var _Paper = require("../Paper");

var _excluded = ["width", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var BOTTOM_HEIGHT = '64px'; // TODO: consider using number for width in units of e.g. 128px columns?

var DIALOG_WIDTH = {
  normal: '504px',
  'settings-panel': '656px',
  'large-settings-panel': '808px'
};

var Container = _styledComponents.default.div.withConfig({
  displayName: "BaseDialog__Container",
  componentId: "sc-4jvxxq-0"
})(["max-height:80vh;width:", ";margin:auto;box-shadow:", ";display:flex;flex-direction:column;color:", ";background-color:", ";"], _ref => {
  var {
    width
  } = _ref;
  return DIALOG_WIDTH[width];
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.shadow.dialog;
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.text01();
}, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.background00();
});

var DialogHeader = _styledComponents.default.div.withConfig({
  displayName: "BaseDialog__DialogHeader",
  componentId: "sc-4jvxxq-1"
})(["display:flex;flex:none;z-index:1;min-height:64px;max-height:96px;"]);

exports.DialogHeader = DialogHeader;

var DialogContent = _styledComponents.default.div.withConfig({
  displayName: "BaseDialog__DialogContent",
  componentId: "sc-4jvxxq-2"
})(["box-sizing:border-box;flex-grow:1;flex-shrink:1;display:flex;flex-direction:column;overflow:auto;"]);

exports.DialogContent = DialogContent;

var DialogFooter = _styledComponents.default.div.withConfig({
  displayName: "BaseDialog__DialogFooter",
  componentId: "sc-4jvxxq-3"
})(["height:", ";display:flex;flex:none;z-index:1;"], BOTTOM_HEIGHT);

exports.DialogFooter = DialogFooter;

var BaseDialog = _ref5 => {
  var {
    width = 'normal',
    children
  } = _ref5,
      modalProps = _objectWithoutProperties(_ref5, _excluded);

  return /*#__PURE__*/_react.default.createElement(_Modal.Modal, modalProps, /*#__PURE__*/_react.default.createElement(_Paper.Paper, null, /*#__PURE__*/_react.default.createElement(Container, {
    width: width
  }, children)));
};

exports.BaseDialog = BaseDialog;