"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Icon = exports.ClickableIcon = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _designparams = require("../designparams");

var _excluded = ["icon", "size"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * TODO: Add RTL-support for icon ? (https://material.io/design/usability/bidirectionality.html#mirroring-elements)
 */
var getSize = size => {
  switch (size) {
    case 'small':
      return _designparams.iconSize.small;

    case 'medium':
      return _designparams.iconSize.medium;

    case 'large':
      return _designparams.iconSize.large;

    case 'extraLarge':
      return _designparams.iconSize.extraLarge;

    default:
      return _designparams.iconSize.medium;
  }
};

var IconContainer = _styledComponents.default.span.withConfig({
  displayName: "Icon__IconContainer",
  componentId: "sc-1g0wq5e-0"
})(["display:inline-flex;align-items:center;justify-content:center;pointer-events:none;overflow:hidden;vertical-align:middle;height:", ";width:", ";> svg{fill:currentColor;height:100%;width:auto;}"], _ref => {
  var {
    size
  } = _ref;
  return getSize(size);
}, _ref2 => {
  var {
    size
  } = _ref2;
  return getSize(size);
});

var Icon = _ref3 => {
  var {
    icon: SvgIcon,
    size = 'medium'
  } = _ref3,
      props = _objectWithoutProperties(_ref3, _excluded);

  return /*#__PURE__*/_react.default.createElement(IconContainer, _extends({
    role: "img",
    size: size
  }, props), /*#__PURE__*/_react.default.createElement(SvgIcon, null));
};

exports.Icon = Icon;
var ClickableIcon = (0, _styledComponents.default)(Icon).attrs({
  tabIndex: 0
}).withConfig({
  displayName: "Icon__ClickableIcon",
  componentId: "sc-1g0wq5e-1"
})(["cursor:pointer;pointer-events:auto;:focus{outline:2px solid ", ";}"], _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.textPrimary();
});
exports.ClickableIcon = ClickableIcon;