"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SimpleTableRow = exports.SimpleTable = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _GlobalScrollbarStyle = require("../Global/GlobalScrollbarStyle");

var _excluded = ["children", "disabled", "onClick"],
    _excluded2 = ["maxHeight", "compact", "header", "widths", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// TODO: this is componentSize, but that one is a string and contains 'px'
var ROW_HEIGHT = 56;
var SIMPLE_ROW_HEIGHT = 32;
/*******************************************************************************
 *
 * SimpleTableContext
 *
 ******************************************************************************/

var SimpleTableContext = /*#__PURE__*/(0, _react.createContext)({
  compact: false,
  columnWidths: []
});
/*******************************************************************************
 *
 * Exported SimpleTable building blocks:
 *  - SimpleTableRow
 *  - SimpleTable
 *
 ******************************************************************************/

/**
 * SimpleTableHeader
 */

var TableHeader = _styledComponents.default.tr.withConfig({
  displayName: "SimpleTable__TableHeader",
  componentId: "sc-1psb6vz-0"
})(["height:", ";text-align:left;display:table;table-layout:fixed;width:100%;"], _ref => {
  var {
    compact
  } = _ref;
  return compact ? _designparams.componentSize.small : _designparams.componentSize.large;
});

var TableHeaderCellContent = _styledComponents.default.th.withConfig({
  displayName: "SimpleTable__TableHeaderCellContent",
  componentId: "sc-1psb6vz-1"
})(["color:", ";background:", ";&:first-child{padding-left:", ";}padding-right:", ";text-align:left;font-weight:", ";user-select:none;", ""], _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text02();
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.background00();
}, _designparams.spacing.extraLarge, _designparams.spacing.large, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.font.fontWeight.normal;
}, _ref5 => {
  var {
    columWidthPercentage
  } = _ref5;
  return columWidthPercentage !== undefined ? (0, _styledComponents.css)(["width:", "%;"], columWidthPercentage) : undefined;
});

var SimpleTableHeader = _ref6 => {
  var {
    children
  } = _ref6;
  var {
    compact,
    columnWidths
  } = (0, _react.useContext)(SimpleTableContext);
  return /*#__PURE__*/_react.default.createElement(TableHeader, {
    compact: compact
  }, _react.default.Children.map(children, (cell, i) => {
    return /*#__PURE__*/_react.default.createElement(TableHeaderCellContent, {
      key: i,
      columWidthPercentage: columnWidths[i]
    }, cell);
  }));
};
/**
 * SimpleTableRow
 *
 * A single row in the table used to group cells.
 */


var TableRow = _styledComponents.default.tr.withConfig({
  displayName: "SimpleTable__TableRow",
  componentId: "sc-1psb6vz-2"
})(["display:table;table-layout:fixed;width:100%;height:", ";text-align:left;transition:box-shadow 200ms;&:nth-child(odd){background-color:", ";}&:nth-child(even){background-color:", ";}&:hover{box-shadow:", ";transform:scale(1);z-index:1;}", ";cursor:", ";"], _ref7 => {
  var {
    compact
  } = _ref7;
  return compact ? _designparams.componentSize.small : _designparams.componentSize.extraLarge;
}, _ref8 => {
  var {
    theme
  } = _ref8;
  return theme.color.background03();
}, _ref9 => {
  var {
    theme
  } = _ref9;
  return theme.color.background00();
}, _ref10 => {
  var {
    theme
  } = _ref10;
  return theme.shadow.tableRow;
}, _ref11 => {
  var {
    disabled
  } = _ref11;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
}, _ref12 => {
  var {
    clickable,
    disabled
  } = _ref12;
  return clickable && !disabled ? 'pointer' : 'unset';
});

var TableCellContent = _styledComponents.default.td.withConfig({
  displayName: "SimpleTable__TableCellContent",
  componentId: "sc-1psb6vz-3"
})(["&:first-child{padding-left:", ";}padding-right:", ";white-space:nowrap;overflow:hidden;text-overflow:ellipsis;", ""], _designparams.spacing.extraLarge, _designparams.spacing.large, _ref13 => {
  var {
    columWidthPercentage
  } = _ref13;
  return columWidthPercentage !== undefined ? (0, _styledComponents.css)(["width:", "%;"], columWidthPercentage) : undefined;
});

var SimpleTableRow = _ref14 => {
  var {
    children,
    disabled = false,
    onClick
  } = _ref14,
      props = _objectWithoutProperties(_ref14, _excluded);

  var {
    compact,
    columnWidths
  } = (0, _react.useContext)(SimpleTableContext);
  var clickable = onClick !== undefined;
  var handleClick = (0, _react.useCallback)(e => {
    if (clickable) {
      e.stopPropagation();
    }

    onClick === null || onClick === void 0 ? void 0 : onClick(e);
  }, [onClick, clickable]);
  return /*#__PURE__*/_react.default.createElement(TableRow, _extends({
    compact: compact,
    disabled: disabled,
    clickable: clickable,
    onClick: handleClick
  }, props), _react.default.Children.map(children, (cell, i) => {
    return /*#__PURE__*/_react.default.createElement(TableCellContent, {
      key: i,
      columWidthPercentage: columnWidths[i]
    }, cell);
  }));
};
/**
 * Table
 *
 * Defined by the number of columns.
 */


exports.SimpleTableRow = SimpleTableRow;

var TableContainer = _styledComponents.default.table.withConfig({
  displayName: "SimpleTable__TableContainer",
  componentId: "sc-1psb6vz-4"
})(["border-collapse:collapse;width:100%;height:100%;overflow-y:auto;position:relative;"]);

var TableHeaderContainer = _styledComponents.default.thead.withConfig({
  displayName: "SimpleTable__TableHeaderContainer",
  componentId: "sc-1psb6vz-5"
})(["display:table;", ""], _ref15 => {
  var {
    hasMargin
  } = _ref15;
  return hasMargin ? (0, _styledComponents.css)(["margin-right:", "px;"], _GlobalScrollbarStyle.SCROLLBAR_DIMENSION) : (0, _styledComponents.css)(["width:100%;"]);
});

var TableContentContainer = _styledComponents.default.tbody.withConfig({
  displayName: "SimpleTable__TableContentContainer",
  componentId: "sc-1psb6vz-6"
})(["display:block;width:100%;max-height:", ";overflow:auto;padding-bottom:", ";border-top:1px solid ", ";"], _ref16 => {
  var {
    maxHeight
  } = _ref16;
  return maxHeight === undefined ? 'initial' : "".concat(maxHeight, "px");
}, _designparams.spacing.medium, _ref17 => {
  var {
    theme
  } = _ref17;
  return theme.color.element12();
});

var SimpleTable = _ref18 => {
  var {
    maxHeight,
    compact: compactFromProps,
    header,
    widths = [],
    children
  } = _ref18,
      props = _objectWithoutProperties(_ref18, _excluded2);

  var {
    compact: compactFromTheme
  } = (0, _styledComponents.useTheme)();
  var compact = compactFromProps !== null && compactFromProps !== void 0 ? compactFromProps : compactFromTheme;
  var [hasOverflow, setHasOverflow] = (0, _react.useState)(false);
  var tableRef = (0, _react.useRef)(null);
  var columnWidths = widths;
  (0, _react.useLayoutEffect)(() => {
    if (tableRef.current === null) {
      return;
    }

    setHasOverflow(tableRef.current.offsetHeight < tableRef.current.scrollHeight || tableRef.current.offsetWidth < tableRef.current.scrollWidth);
  }, [tableRef]);

  var [...rows] = _react.default.Children.toArray(children);

  var contentHeight = maxHeight !== undefined ? maxHeight * (compact ? SIMPLE_ROW_HEIGHT : ROW_HEIGHT) : undefined;
  return /*#__PURE__*/_react.default.createElement(TableContainer, props, /*#__PURE__*/_react.default.createElement(SimpleTableContext.Provider, {
    value: {
      compact,
      columnWidths
    }
  }, /*#__PURE__*/_react.default.createElement(TableHeaderContainer, {
    hasMargin: hasOverflow
  }, /*#__PURE__*/_react.default.createElement(SimpleTableHeader, null, header)), /*#__PURE__*/_react.default.createElement(TableContentContainer, {
    ref: tableRef,
    maxHeight: contentHeight
  }, rows)));
};

exports.SimpleTable = SimpleTable;