"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Spinner = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _excluded = ["type", "label"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// Constant size for spinner
var SPINNER_SIZE = _designparams.componentSize.small;

var Container = _styledComponents.default.div.withConfig({
  displayName: "Spinner__Container",
  componentId: "sc-bu68ag-0"
})(["display:inline-flex;flex-direction:column;justify-content:space-between;align-items:center;vertical-align:middle;"]);

var rotate = (0, _styledComponents.keyframes)(["from{transform:rotate(90deg);}to{transform:rotate(450deg);}"]);

var Circle = _styledComponents.default.div.withConfig({
  displayName: "Spinner__Circle",
  componentId: "sc-bu68ag-1"
})(["width:", ";height:", ";box-sizing:border-box;border-radius:", ";border-width:2px;border-color:", ";transform:rotate(90deg);animation:", " linear infinite;:dir(rtl){animation-direction:reverse;}", ""], SPINNER_SIZE, SPINNER_SIZE, _designparams.shape.radius.circle, _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background01();
}, rotate, _ref2 => {
  var {
    type
  } = _ref2;
  return type === 'primary' ? (0, _styledComponents.css)(["border-style:solid;border-left:2px solid ", ";animation-duration:2s;"], _ref3 => {
    var {
      theme
    } = _ref3;
    return theme.color.elementPrimary();
  }) : (0, _styledComponents.css)(["border-style:dashed;animation-duration:10s;"]);
});

var Label = _styledComponents.default.div.withConfig({
  displayName: "Spinner__Label",
  componentId: "sc-bu68ag-2"
})(["margin-top:", ";color:", ";"], _designparams.spacing.medium, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.text01();
});

var Spinner = _ref5 => {
  var {
    type = 'primary',
    label
  } = _ref5,
      props = _objectWithoutProperties(_ref5, _excluded);

  return /*#__PURE__*/_react.default.createElement(Container, props, /*#__PURE__*/_react.default.createElement(Circle, {
    type: type
  }), label !== undefined && label.length > 0 ? /*#__PURE__*/_react.default.createElement(Label, null, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "navigation-label"
  }, label)) : null);
};

exports.Spinner = Spinner;