import React from 'react';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
export interface StrengthIndicatorProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Used to indicate the strength value of the indicator.
     */
    readonly strength: number;
    /**
     * A string used to tell the user information regarding the strength value.
     */
    readonly helpText: string;
}
export declare const StrengthIndicator: React.FC<StrengthIndicatorProps>;
export {};
