"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WithUnitLabelContainer = exports.Unit = exports.Label = void 0;
exports.withField = withField;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Typography = require("../Typography");

var _designparams = require("../designparams");

var _excluded = ["label", "unitLabel"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Label = _styledComponents.default.div.withConfig({
  displayName: "withField__Label",
  componentId: "sc-4hzzqu-0"
})(["height:", ";display:flex;align-items:center;color:", ";cursor:default;", ";"], _ref => {
  var {
    compact
  } = _ref;
  return !compact ? _designparams.componentSize.medium : _designparams.componentSize.small;
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text03();
}, _ref3 => {
  var {
    disabled
  } = _ref3;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
});

exports.Label = Label;

var WithUnitLabelContainer = _styledComponents.default.div.withConfig({
  displayName: "withField__WithUnitLabelContainer",
  componentId: "sc-4hzzqu-1"
})(["display:flex;flex-direction:row;align-items:center;"]);

exports.WithUnitLabelContainer = WithUnitLabelContainer;
var Unit = (0, _styledComponents.default)(_Typography.Typography).withConfig({
  displayName: "withField__Unit",
  componentId: "sc-4hzzqu-2"
})(["color:", ";margin-left:", ";flex-shrink:0;", ";"], _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.text03();
}, _designparams.spacing.medium, _ref5 => {
  var {
    disabled
  } = _ref5;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
});
exports.Unit = Unit;

function withField(InputComponent) {
  // eslint-disable-next-line react/display-name
  return _ref6 => {
    var _props$compact, _props$disabled;

    var {
      label,
      unitLabel
    } = _ref6,
        props = _objectWithoutProperties(_ref6, _excluded);

    var {
      compact: compactFromTheme
    } = (0, _styledComponents.useTheme)();
    var compact = (_props$compact = props.compact) !== null && _props$compact !== void 0 ? _props$compact : compactFromTheme;
    var disabled = (_props$disabled = props.disabled) !== null && _props$disabled !== void 0 ? _props$disabled : false;
    return /*#__PURE__*/_react.default.createElement("div", null, label !== undefined ? /*#__PURE__*/_react.default.createElement(Label, {
      compact: compact,
      disabled: disabled
    }, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
      variant: "navigation-label"
    }, label)) : null, unitLabel !== undefined ? /*#__PURE__*/_react.default.createElement(WithUnitLabelContainer, null, /*#__PURE__*/_react.default.createElement(InputComponent, props), /*#__PURE__*/_react.default.createElement(Unit, {
      variant: "explanatory-text",
      disabled: disabled
    }, unitLabel)) : /*#__PURE__*/_react.default.createElement(InputComponent, props));
  };
}